"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports["default"]=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _asyncToGenerator2=_interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));var _classCallCheck2=_interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));var _createClass2=_interopRequireDefault(require("@babel/runtime/helpers/createClass"));var _path=_interopRequireDefault(require("path"));var _fs=_interopRequireDefault(require("fs"));var _json=_interopRequireDefault(require("json5"));var _typescriptEstree=require("@typescript-eslint/typescript-estree");var _Definition=_interopRequireDefault(require("./Definition"));var _Reference=_interopRequireDefault(require("./Reference"));var _ServiceFile=_interopRequireDefault(require("./ServiceFile"));var _AutowireIdentifier=_interopRequireDefault(require("./AutowireIdentifier"));var _ContainerDefaultDirMustBeSet=_interopRequireDefault(require("./Exception/ContainerDefaultDirMustBeSet"));function _createForOfIteratorHelper(o,allowArrayLike){var it=typeof Symbol!=="undefined"&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=_unsupportedIterableToArray(o))||allowArrayLike&&o&&typeof o.length==="number"){if(it)o=it;var i=0;var F=function F(){};return{s:F,n:function n(){if(i>=o.length)return{done:true};return{done:false,value:o[i++]};},e:function e(_e){throw _e;},f:F};}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");}var normalCompletion=true,didErr=false,err;return{s:function s(){it=it.call(o);},n:function n(){var step=it.next();normalCompletion=step.done;return step;},e:function e(_e2){didErr=true;err=_e2;},f:function f(){try{if(!normalCompletion&&it["return"]!=null)it["return"]();}finally{if(didErr)throw err;}}};}function _unsupportedIterableToArray(o,minLen){if(!o)return;if(typeof o==="string")return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);if(n==="Object"&&o.constructor)n=o.constructor.name;if(n==="Map"||n==="Set")return Array.from(o);if(n==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen);}function _arrayLikeToArray(arr,len){if(len==null||len>arr.length)len=arr.length;for(var i=0,arr2=new Array(len);i<len;i++){arr2[i]=arr[i];}return arr2;}var Autowire=function(){function Autowire(container){var tsConfigFullPath=arguments.length>1&&arguments[1]!==undefined?arguments[1]:null;(0,_classCallCheck2["default"])(this,Autowire);this._ensureContainerIsValidForAutowire(container);this._rootDirectory=container.defaultDir;this._container=container;this._excludedFolders=[];this._serviceFile=null;try{this._tsConfigFullPath=tsConfigFullPath||_path["default"].join(process.cwd(),'tsconfig.json');this._tsConfigPaths=_json["default"].parse(_fs["default"].readFileSync(this._tsConfigFullPath,'utf-8')).compilerOptions.paths;}catch(e){this._tsConfigPaths=null;}}(0,_createClass2["default"])(Autowire,[{key:"_ensureContainerIsValidForAutowire",value:function _ensureContainerIsValidForAutowire(container){if(container.defaultDir===null){throw new _ContainerDefaultDirMustBeSet["default"]();}}},{key:"container",get:function get(){return this._container;}},{key:"_walk",value:_regenerator["default"].mark(function _walk(dir){var files,_iterator,_step,file,filePath;return _regenerator["default"].wrap(function _walk$(_context){while(1){switch(_context.prev=_context.next){case 0:files=_fs["default"].readdirSync(dir,{withFileTypes:true});_iterator=_createForOfIteratorHelper(files);_context.prev=2;_iterator.s();case 4:if((_step=_iterator.n()).done){_context.next=20;break;}file=_step.value;if(!file.isDirectory()){_context.next=9;break;}return _context.delegateYield(this._walk(_path["default"].join(dir,file.name)),"t0",8);case 8:return _context.abrupt("continue",18);case 9:filePath=_path["default"].join(dir,file.name);_context.prev=10;this._ensureFileIsNotExcluded(filePath);_context.next=14;return filePath;case 14:_context.next=18;break;case 16:_context.prev=16;_context.t1=_context["catch"](10);case 18:_context.next=4;break;case 20:_context.next=25;break;case 22:_context.prev=22;_context.t2=_context["catch"](2);_iterator.e(_context.t2);case 25:_context.prev=25;_iterator.f();return _context.finish(25);case 28:case"end":return _context.stop();}}},_walk,this,[[2,22,25,28],[10,16]]);})},{key:"_ensureFileIsNotExcluded",value:function _ensureFileIsNotExcluded(filePath){this._excludedFolders.forEach(function(excludedFolder){if(filePath.includes(excludedFolder)){throw new Error('Excluded Folder!');}});}},{key:"addExclude",value:function addExclude(relativePath){var fullPathToExclude=_path["default"].join(this._rootDirectory,relativePath);this._excludedFolders.push(fullPathToExclude);}},{key:"_getServiceIdFromPath",value:function(){var _getServiceIdFromPath2=(0,_asyncToGenerator2["default"])(_regenerator["default"].mark(function _callee(path,type){var extension,readableId,_args2=arguments;return _regenerator["default"].wrap(function _callee$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:extension=_args2.length>2&&_args2[2]!==undefined?_args2[2]:'.ts';readableId=path.replace(/\//g,'__').replace(extension,'').replace('@','__').concat("__".concat(type));return _context2.abrupt("return",_AutowireIdentifier["default"].encode(readableId));case 3:case"end":return _context2.stop();}}},_callee);}));function _getServiceIdFromPath(_x,_x2){return _getServiceIdFromPath2.apply(this,arguments);}return _getServiceIdFromPath;}()},{key:"process",value:function(){var _process=(0,_asyncToGenerator2["default"])(_regenerator["default"].mark(function _callee2(){var promises,_iterator2,_step2,filePath;return _regenerator["default"].wrap(function _callee2$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:promises=[];_iterator2=_createForOfIteratorHelper(this._walk(this._rootDirectory));try{for(_iterator2.s();!(_step2=_iterator2.n()).done;){filePath=_step2.value;promises.push(this._executeFilePath(filePath));}}catch(err){_iterator2.e(err);}finally{_iterator2.f();}_context3.next=5;return Promise.all(promises);case 5:if(!(this._serviceFile instanceof _ServiceFile["default"])){_context3.next=8;break;}_context3.next=8;return this._serviceFile.generateFromContainer(this._container);case 8:case"end":return _context3.stop();}}},_callee2,this);}));function process(){return _process.apply(this,arguments);}return process;}()},{key:"_executeFilePath",value:function(){var _executeFilePath2=(0,_asyncToGenerator2["default"])(_regenerator["default"].mark(function _callee3(filePath){var parsedFile,_yield$this$_getClass,classDeclaration,body,Class,definition,serviceId;return _regenerator["default"].wrap(function _callee3$(_context4){while(1){switch(_context4.prev=_context4.next){case 0:parsedFile=_path["default"].parse(filePath);if(!(parsedFile.ext!=='.ts')){_context4.next=3;break;}return _context4.abrupt("return");case 3:_context4.next=5;return this._getClassDeclaration(filePath);case 5:_yield$this$_getClass=_context4.sent;classDeclaration=_yield$this$_getClass.classDeclaration;body=_yield$this$_getClass.body;if(classDeclaration){_context4.next=10;break;}return _context4.abrupt("return");case 10:Class=require(filePath)["default"];if(Class){_context4.next=13;break;}return _context4.abrupt("return");case 13:_context4.next=15;return this._getDefinition(classDeclaration,body,parsedFile,Class);case 15:definition=_context4.sent;if(definition){_context4.next=18;break;}return _context4.abrupt("return");case 18:_context4.next=20;return this._getServiceIdFromPath(filePath,Class.name);case 20:serviceId=_context4.sent;this.container.setDefinition(serviceId,definition);_context4.next=24;return this._interfaceImplementations(classDeclaration,body,parsedFile,serviceId);case 24:case"end":return _context4.stop();}}},_callee3,this);}));function _executeFilePath(_x3){return _executeFilePath2.apply(this,arguments);}return _executeFilePath;}()},{key:"_getClassDeclaration",value:function(){var _getClassDeclaration2=(0,_asyncToGenerator2["default"])(_regenerator["default"].mark(function _callee4(filePath){var sourceCode,body,classDeclaration;return _regenerator["default"].wrap(function _callee4$(_context5){while(1){switch(_context5.prev=_context5.next){case 0:sourceCode=_fs["default"].readFileSync(filePath,'utf8');body=(0,_typescriptEstree.parse)(sourceCode).body;classDeclaration=body.find(function(declaration){return declaration.type==='ExportDefaultDeclaration';});return _context5.abrupt("return",{classDeclaration:classDeclaration,body:body});case 4:case"end":return _context5.stop();}}},_callee4);}));function _getClassDeclaration(_x4){return _getClassDeclaration2.apply(this,arguments);}return _getClassDeclaration;}()},{key:"_getDefinition",value:function(){var _getDefinition2=(0,_asyncToGenerator2["default"])(_regenerator["default"].mark(function _callee5(classDeclaration,body,parsedFile,ServiceClass){var definition,constructorParams,_iterator3,_step3,parameterDeclaration,typeNameForArgument,argumentId;return _regenerator["default"].wrap(function _callee5$(_context6){while(1){switch(_context6.prev=_context6.next){case 0:_context6.prev=0;definition=new _Definition["default"](ServiceClass);_context6.next=4;return this._getConstructorParamsByDefinition(definition,classDeclaration,body,parsedFile);case 4:constructorParams=_context6.sent;_iterator3=_createForOfIteratorHelper(constructorParams);_context6.prev=6;_iterator3.s();case 8:if((_step3=_iterator3.n()).done){_context6.next=19;break;}parameterDeclaration=_step3.value;typeNameForArgument=parameterDeclaration.parameter.typeAnnotation.typeAnnotation.typeName.name;_context6.next=13;return this._getIdentifierFromImports(typeNameForArgument,body,parsedFile);case 13:argumentId=_context6.sent;if(argumentId){_context6.next=16;break;}return _context6.abrupt("continue",17);case 16:definition.addArgument(new _Reference["default"](argumentId),definition["abstract"]);case 17:_context6.next=8;break;case 19:_context6.next=24;break;case 21:_context6.prev=21;_context6.t0=_context6["catch"](6);_iterator3.e(_context6.t0);case 24:_context6.prev=24;_iterator3.f();return _context6.finish(24);case 27:return _context6.abrupt("return",definition);case 30:_context6.prev=30;_context6.t1=_context6["catch"](0);case 32:case"end":return _context6.stop();}}},_callee5,this,[[0,30],[6,21,24,27]]);}));function _getDefinition(_x5,_x6,_x7,_x8){return _getDefinition2.apply(this,arguments);}return _getDefinition;}()},{key:"_getConstructorParamsByDefinition",value:function(){var _getConstructorParamsByDefinition2=(0,_asyncToGenerator2["default"])(_regenerator["default"].mark(function _callee6(definition,classDeclaration,body,parsedFile){var constructorDeclaration;return _regenerator["default"].wrap(function _callee6$(_context7){while(1){switch(_context7.prev=_context7.next){case 0:constructorDeclaration=classDeclaration.declaration.body.body.find(function(method){return method.key.name==='constructor';});if(classDeclaration.declaration["abstract"]){definition["abstract"]=true;}_context7.next=4;return this._parentDefinition(classDeclaration,body,parsedFile,definition);case 4:return _context7.abrupt("return",constructorDeclaration?constructorDeclaration.value.params:[]);case 5:case"end":return _context7.stop();}}},_callee6,this);}));function _getConstructorParamsByDefinition(_x9,_x10,_x11,_x12){return _getConstructorParamsByDefinition2.apply(this,arguments);}return _getConstructorParamsByDefinition;}()},{key:"_parentDefinition",value:function(){var _parentDefinition2=(0,_asyncToGenerator2["default"])(_regenerator["default"].mark(function _callee7(classDeclaration,body,parsedFile,definition){var typeParent,parentId;return _regenerator["default"].wrap(function _callee7$(_context8){while(1){switch(_context8.prev=_context8.next){case 0:if(!classDeclaration.declaration.superClass){_context8.next=6;break;}typeParent=classDeclaration.declaration.superClass.name;_context8.next=4;return this._getIdentifierFromImports(typeParent,body,parsedFile);case 4:parentId=_context8.sent;if(parentId){definition.parent=parentId;}case 6:case"end":return _context8.stop();}}},_callee7,this);}));function _parentDefinition(_x13,_x14,_x15,_x16){return _parentDefinition2.apply(this,arguments);}return _parentDefinition;}()},{key:"_interfaceImplementations",value:function(){var _interfaceImplementations2=(0,_asyncToGenerator2["default"])(_regenerator["default"].mark(function _callee8(classDeclaration,body,parsedFile,serviceId){var _classDeclaration$dec;var implementations,_iterator4,_step4,implement,interfaceType,aliasId;return _regenerator["default"].wrap(function _callee8$(_context9){while(1){switch(_context9.prev=_context9.next){case 0:implementations=(_classDeclaration$dec=classDeclaration.declaration["implements"])!==null&&_classDeclaration$dec!==void 0?_classDeclaration$dec:[];_iterator4=_createForOfIteratorHelper(implementations);_context9.prev=2;_iterator4.s();case 4:if((_step4=_iterator4.n()).done){_context9.next=15;break;}implement=_step4.value;interfaceType=implement.expression.name;_context9.next=9;return this._getIdentifierFromImports(interfaceType,body,parsedFile);case 9:aliasId=_context9.sent;if(!(!aliasId||this.container.hasAlias(aliasId))){_context9.next=12;break;}return _context9.abrupt("continue",13);case 12:this.container.setAlias(aliasId,serviceId);case 13:_context9.next=4;break;case 15:_context9.next=20;break;case 17:_context9.prev=17;_context9.t0=_context9["catch"](2);_iterator4.e(_context9.t0);case 20:_context9.prev=20;_iterator4.f();return _context9.finish(20);case 23:case"end":return _context9.stop();}}},_callee8,this,[[2,17,20,23]]);}));function _interfaceImplementations(_x17,_x18,_x19,_x20){return _interfaceImplementations2.apply(this,arguments);}return _interfaceImplementations;}()},{key:"_getIdentifierFromImports",value:function(){var _getIdentifierFromImports2=(0,_asyncToGenerator2["default"])(_regenerator["default"].mark(function _callee9(type,body,parsedFile){var _this$_tsConfigPaths,rootDir,relativeImportForImplement,configPaths,pathConfig,tsConfigPath,tsRelativePath,parsedTsConfigPath,absolutePathImportForImplement;return _regenerator["default"].wrap(function _callee9$(_context10){while(1){switch(_context10.prev=_context10.next){case 0:_context10.prev=0;rootDir=parsedFile.dir;_context10.next=4;return this._getRelativeImport(body,type);case 4:relativeImportForImplement=_context10.sent;configPaths=(_this$_tsConfigPaths=this._tsConfigPaths)!==null&&_this$_tsConfigPaths!==void 0?_this$_tsConfigPaths:[];_context10.t0=_regenerator["default"].keys(configPaths);case 7:if((_context10.t1=_context10.t0()).done){_context10.next=18;break;}pathConfig=_context10.t1.value;tsConfigPath=pathConfig.replace(/\*/g,'');tsRelativePath=this._tsConfigPaths[pathConfig][0].replace(/\*/g,'');if(relativeImportForImplement.includes(tsConfigPath)){_context10.next=13;break;}return _context10.abrupt("continue",7);case 13:relativeImportForImplement=relativeImportForImplement.replace(tsConfigPath,tsRelativePath);parsedTsConfigPath=_path["default"].parse(this._tsConfigFullPath);rootDir=parsedTsConfigPath.dir;_context10.next=7;break;case 18:absolutePathImportForImplement=_path["default"].join(rootDir,relativeImportForImplement);return _context10.abrupt("return",this._getServiceIdFromPath(absolutePathImportForImplement,type));case 22:_context10.prev=22;_context10.t2=_context10["catch"](0);case 24:case"end":return _context10.stop();}}},_callee9,this,[[0,22]]);}));function _getIdentifierFromImports(_x21,_x22,_x23){return _getIdentifierFromImports2.apply(this,arguments);}return _getIdentifierFromImports;}()},{key:"_getRelativeImport",value:function(){var _getRelativeImport2=(0,_asyncToGenerator2["default"])(_regenerator["default"].mark(function _callee10(body,type){return _regenerator["default"].wrap(function _callee10$(_context11){while(1){switch(_context11.prev=_context11.next){case 0:return _context11.abrupt("return",body.find(function(declaration){if(declaration.specifiers){return declaration.specifiers.find(function(specifier){return specifier.local.name===type;});}return null;}).source.value);case 1:case"end":return _context11.stop();}}},_callee10);}));function _getRelativeImport(_x24,_x25){return _getRelativeImport2.apply(this,arguments);}return _getRelativeImport;}()},{key:"serviceFile",get:function get(){return this._serviceFile;},set:function set(serviceFile){this._serviceFile=serviceFile;}}]);return Autowire;}();exports["default"]=Autowire;