"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports["default"]=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _asyncToGenerator2=_interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));var _classCallCheck2=_interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));var _createClass2=_interopRequireDefault(require("@babel/runtime/helpers/createClass"));var _PassConfig=_interopRequireDefault(require("../PassConfig"));var _OptimizePass=_interopRequireDefault(require("./OptimizePass"));var _RemovePass=_interopRequireDefault(require("./RemovePass"));var _DecoratePass=_interopRequireDefault(require("./DecoratePass"));var _ProcessMethodNotFoundException=_interopRequireDefault(require("../Exception/ProcessMethodNotFoundException"));var _WrongCompilerPassTypeException=_interopRequireDefault(require("../Exception/WrongCompilerPassTypeException"));function _createForOfIteratorHelper(o,allowArrayLike){var it=typeof Symbol!=="undefined"&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=_unsupportedIterableToArray(o))||allowArrayLike&&o&&typeof o.length==="number"){if(it)o=it;var i=0;var F=function F(){};return{s:F,n:function n(){if(i>=o.length)return{done:true};return{done:false,value:o[i++]};},e:function e(_e){throw _e;},f:F};}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");}var normalCompletion=true,didErr=false,err;return{s:function s(){it=it.call(o);},n:function n(){var step=it.next();normalCompletion=step.done;return step;},e:function e(_e2){didErr=true;err=_e2;},f:function f(){try{if(!normalCompletion&&it["return"]!=null)it["return"]();}finally{if(didErr)throw err;}}};}function _unsupportedIterableToArray(o,minLen){if(!o)return;if(typeof o==="string")return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);if(n==="Object"&&o.constructor)n=o.constructor.name;if(n==="Map"||n==="Set")return Array.from(o);if(n==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen);}function _arrayLikeToArray(arr,len){if(len==null||len>arr.length)len=arr.length;for(var i=0,arr2=new Array(len);i<len;i++){arr2[i]=arr[i];}return arr2;}var CompilerPass=function(){function CompilerPass(container){(0,_classCallCheck2["default"])(this,CompilerPass);this._container=container;this.beforeOptimization=[];this.optimize=[];this.beforeRemoving=[];this.remove=[];this.afterRemoving=[];}(0,_createClass2["default"])(CompilerPass,[{key:"_getCompilerPassPriorityNumber",value:function _getCompilerPassPriorityNumber(type,priority){if(this[type][priority]){return this._getCompilerPassPriorityNumber(type,priority+1);}return priority;}},{key:"register",value:function register(compilerPass,type,priority){if(typeof compilerPass.process!=='function'){throw new _ProcessMethodNotFoundException["default"](compilerPass.constructor.name);}if(!_PassConfig["default"].isValidType(type)){throw new _WrongCompilerPassTypeException["default"](type);}var arrayLevel=this._getCompilerPassPriorityNumber(type,priority);this[type][arrayLevel]=compilerPass;}},{key:"_checkAndAdd",value:function(){var _checkAndAdd2=(0,_asyncToGenerator2["default"])(_regenerator["default"].mark(function _callee(type){return _regenerator["default"].wrap(function _callee$(_context){while(1){switch(_context.prev=_context.next){case 0:if(this._container._compilerPass[type].length===0){if(type===_PassConfig["default"].TYPE_BEFORE_OPTIMIZATION){this.register(new _DecoratePass["default"](),type,0);}else if(type===_PassConfig["default"].TYPE_OPTIMIZE){this.register(new _OptimizePass["default"](),type,0);}else if(type===_PassConfig["default"].TYPE_REMOVE){this.register(new _RemovePass["default"](),type,0);}}case 1:case"end":return _context.stop();}}},_callee,this);}));function _checkAndAdd(_x){return _checkAndAdd2.apply(this,arguments);}return _checkAndAdd;}()},{key:"process",value:function(){var _process=(0,_asyncToGenerator2["default"])(_regenerator["default"].mark(function _callee2(type){var promises,_iterator,_step,compilerPass;return _regenerator["default"].wrap(function _callee2$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:_context2.next=2;return this._checkAndAdd(type);case 2:this[type]=this[type].filter(function(i){return i!==null;});promises=[];_iterator=_createForOfIteratorHelper(this[type]);try{for(_iterator.s();!(_step=_iterator.n()).done;){compilerPass=_step.value;promises.push(compilerPass.process(this._container));}}catch(err){_iterator.e(err);}finally{_iterator.f();}_context2.next=8;return Promise.all(promises);case 8:case"end":return _context2.stop();}}},_callee2,this);}));function process(_x2){return _process.apply(this,arguments);}return process;}()}]);return CompilerPass;}();exports["default"]=CompilerPass;