"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports["default"]=void 0;var _slicedToArray2=_interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));var _construct2=_interopRequireDefault(require("@babel/runtime/helpers/construct"));var _toConsumableArray2=_interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));var _classCallCheck2=_interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));var _createClass2=_interopRequireDefault(require("@babel/runtime/helpers/createClass"));var _Reference=_interopRequireDefault(require("./Reference"));var _TagReference=_interopRequireDefault(require("./TagReference"));var _PackageReference=_interopRequireDefault(require("./PackageReference"));var _PrivateServiceException=_interopRequireDefault(require("./Exception/PrivateServiceException"));var _ServiceNotFoundException=_interopRequireDefault(require("./Exception/ServiceNotFoundException"));var _NotAbstractServiceException=_interopRequireDefault(require("./Exception/NotAbstractServiceException"));var _MethodCallNotFoundException=_interopRequireDefault(require("./Exception/MethodCallNotFoundException"));var _AbstractServiceException=_interopRequireDefault(require("./Exception/AbstractServiceException"));var _UnableToGetInstanceFromId=_interopRequireDefault(require("./Exception/UnableToGetInstanceFromId"));function _createForOfIteratorHelper(o,allowArrayLike){var it=typeof Symbol!=="undefined"&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=_unsupportedIterableToArray(o))||allowArrayLike&&o&&typeof o.length==="number"){if(it)o=it;var i=0;var F=function F(){};return{s:F,n:function n(){if(i>=o.length)return{done:true};return{done:false,value:o[i++]};},e:function e(_e){throw _e;},f:F};}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");}var normalCompletion=true,didErr=false,err;return{s:function s(){it=it.call(o);},n:function n(){var step=it.next();normalCompletion=step.done;return step;},e:function e(_e2){didErr=true;err=_e2;},f:function f(){try{if(!normalCompletion&&it["return"]!=null)it["return"]();}finally{if(didErr)throw err;}}};}function _unsupportedIterableToArray(o,minLen){if(!o)return;if(typeof o==="string")return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);if(n==="Object"&&o.constructor)n=o.constructor.name;if(n==="Map"||n==="Set")return Array.from(o);if(n==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen);}function _arrayLikeToArray(arr,len){if(len==null||len>arr.length)len=arr.length;for(var i=0,arr2=new Array(len);i<len;i++){arr2[i]=arr[i];}return arr2;}var InstanceManager=function(){function InstanceManager(containerBuilder,definitions,alias){(0,_classCallCheck2["default"])(this,InstanceManager);this._containerBuilder=containerBuilder;this._definitions=definitions;this._alias=alias;}(0,_createClass2["default"])(InstanceManager,[{key:"_getInstanceFromStringId",value:function _getInstanceFromStringId(id,bypassPublic){id=this._alias.get(id)||id;if(id==='service_container'&&this._containerBuilder.containerReferenceAsService){return this._containerBuilder;}if(this._definitions.has(id)){return this._getInstanceFromId(id,bypassPublic);}this._containerBuilder.logger.warn("The service ".concat(id," is not registered"));throw new _ServiceNotFoundException["default"](id);}},{key:"_getInstanceFromFunction",value:function _getInstanceFromFunction(functionName,bypassPublic){var definitionServiceId=null;this._definitions.forEach(function(definition,serviceId){if(definition.Object===functionName){definitionServiceId=serviceId;}});if(definitionServiceId){return this.getInstance(definitionServiceId,bypassPublic);}this._containerBuilder.logger.warn("The service ".concat(functionName.name," is not registered"));throw new _ServiceNotFoundException["default"](functionName);}},{key:"getInstance",value:function getInstance(id){var bypassPublic=arguments.length>1&&arguments[1]!==undefined?arguments[1]:false;if(typeof id==='string'){return this._getInstanceFromStringId(id,bypassPublic);}if(typeof id==='function'){return this._getInstanceFromFunction(id,bypassPublic);}throw new _UnableToGetInstanceFromId["default"](id);}},{key:"_getInstanceFromId",value:function _getInstanceFromId(id){var bypassPublic=arguments.length>1&&arguments[1]!==undefined?arguments[1]:false;var definition=this._definitions.get(id);if(!definition["public"]&&!bypassPublic){throw new _PrivateServiceException["default"](id);}if(definition["abstract"]){throw new _AbstractServiceException["default"](id);}if(definition.deprecated){this._containerBuilder.logger.warn('DEPRECATED',definition.deprecated);}if(definition.Object||definition.factory||!definition.Object&&definition.synthetic){return this._getExistingInstanceFromId(id,bypassPublic);}this._containerBuilder.logger.warn("The service ".concat(id," is not registered"));throw new _ServiceNotFoundException["default"](id);}},{key:"_getExistingInstanceFromId",value:function _getExistingInstanceFromId(id){var bypassPublic=arguments.length>1&&arguments[1]!==undefined?arguments[1]:false;var definition=this._definitions.get(id);if(definition.shared===false){return this.getInstanceFromDefinition(definition);}if(this._containerBuilder.services.has(id)&&definition.isPublic(bypassPublic)){return this._containerBuilder.services.get(id);}var instance=this.getInstanceFromDefinition(definition);this._containerBuilder.services.set(id,instance);return instance;}},{key:"getInstanceFromDefinition",value:function getInstanceFromDefinition(definition){if(definition.factory){return this._getInstanceFromFactory(definition);}if(!definition.synthetic){return this._getNotSyntheticInstanceFromDefinition(definition);}}},{key:"_getNotSyntheticInstanceFromDefinition",value:function _getNotSyntheticInstanceFromDefinition(definition){var args=this._resolveArguments(definition.args);try{args=this._appendParentArgumentsFromDefinition(definition.parent,args);}catch(e){if(e instanceof _NotAbstractServiceException["default"]){throw e;}}var instance=(0,_construct2["default"])(definition.Object,(0,_toConsumableArray2["default"])(args));var _iterator=_createForOfIteratorHelper(definition.properties),_step;try{for(_iterator.s();!(_step=_iterator.n()).done;){var _step$value=(0,_slicedToArray2["default"])(_step.value,2),key=_step$value[0],value=_step$value[1];instance[key]=this._resolveServices(value);}}catch(err){_iterator.e(err);}finally{_iterator.f();}var _iterator2=_createForOfIteratorHelper(definition.calls),_step2;try{for(_iterator2.s();!(_step2=_iterator2.n()).done;){var call=_step2.value;this._callMethod(instance,call);}}catch(err){_iterator2.e(err);}finally{_iterator2.f();}return instance;}},{key:"_appendParentArgumentsFromDefinition",value:function _appendParentArgumentsFromDefinition(definitionParent){var args=arguments.length>1&&arguments[1]!==undefined?arguments[1]:[];if(definitionParent){var parentDefinition=this._definitions.get(definitionParent);if(!parentDefinition["abstract"]){throw new _NotAbstractServiceException["default"](definitionParent);}return args.concat(this._resolveArguments(parentDefinition.appendArgs));}return args;}},{key:"_getInstanceFromFactory",value:function _getInstanceFromFactory(definition){var _definition$factory$O;var args=this._resolveArguments(definition.args);if(definition.factory.Object instanceof _Reference["default"]){var _factoryService$const;var factoryService=this._containerBuilder.get(definition.factory.Object.id);return(_factoryService$const=factoryService.constructor)[definition.factory.method].apply(_factoryService$const,(0,_toConsumableArray2["default"])(args));}return(_definition$factory$O=definition.factory.Object)[definition.factory.method].apply(_definition$factory$O,(0,_toConsumableArray2["default"])(args));}},{key:"_resolveArguments",value:function _resolveArguments(){var args=arguments.length>0&&arguments[0]!==undefined?arguments[0]:[];var resolvedArgument=[];var _iterator3=_createForOfIteratorHelper(args),_step3;try{for(_iterator3.s();!(_step3=_iterator3.n()).done;){var argument=_step3.value;resolvedArgument.push(this._resolveServices(argument));}}catch(err){_iterator3.e(err);}finally{_iterator3.f();}return resolvedArgument;}},{key:"_resolveServices",value:function _resolveServices(value){if(value instanceof _Reference["default"]){if(!value.nullable||value.nullable&&this._containerBuilder.hasDefinition(value.id)){return this.getInstance(value.id,true);}}else if(value instanceof _PackageReference["default"]){return require(value.id);}else if(value instanceof _TagReference["default"]){return this._findTaggedServices(value.name);}else{return value;}return null;}},{key:"_findTaggedServices",value:function _findTaggedServices(tagName){var taggedServices=[];var _iterator4=_createForOfIteratorHelper(this._definitions),_step4;try{for(_iterator4.s();!(_step4=_iterator4.n()).done;){var _step4$value=(0,_slicedToArray2["default"])(_step4.value,2),id=_step4$value[0],definition=_step4$value[1];if(definition.tags.some(function(tag){return tag.name===tagName;})){var serviceInstance=this.getInstance(id);taggedServices.push(serviceInstance);}}}catch(err){_iterator4.e(err);}finally{_iterator4.f();}return taggedServices;}},{key:"_callMethod",value:function _callMethod(service,call){if(typeof service[call.method]!=='function'){throw new _MethodCallNotFoundException["default"](call.method);}var args=this._resolveArguments(call.args);service[call.method].apply(service,(0,_toConsumableArray2["default"])(args));}}]);return InstanceManager;}();exports["default"]=InstanceManager;