"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports["default"]=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _slicedToArray2=_interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));var _asyncToGenerator2=_interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));var _classCallCheck2=_interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));var _createClass2=_interopRequireDefault(require("@babel/runtime/helpers/createClass"));var _path=_interopRequireDefault(require("path"));var _ServiceFileNotAbsolute=_interopRequireDefault(require("./Exception/ServiceFileNotAbsolute"));var _ServiceFileNotValidExtension=_interopRequireDefault(require("./Exception/ServiceFileNotValidExtension"));var _YamlDumper=_interopRequireDefault(require("./Dump/YamlDumper"));var _JsonDumper=_interopRequireDefault(require("./Dump/JsonDumper"));var _JsDumper=_interopRequireDefault(require("./Dump/JsDumper"));var _AutowireIdentifier=_interopRequireDefault(require("./AutowireIdentifier"));function _createForOfIteratorHelper(o,allowArrayLike){var it=typeof Symbol!=="undefined"&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=_unsupportedIterableToArray(o))||allowArrayLike&&o&&typeof o.length==="number"){if(it)o=it;var i=0;var F=function F(){};return{s:F,n:function n(){if(i>=o.length)return{done:true};return{done:false,value:o[i++]};},e:function e(_e){throw _e;},f:F};}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");}var normalCompletion=true,didErr=false,err;return{s:function s(){it=it.call(o);},n:function n(){var step=it.next();normalCompletion=step.done;return step;},e:function e(_e2){didErr=true;err=_e2;},f:function f(){try{if(!normalCompletion&&it["return"]!=null)it["return"]();}finally{if(didErr)throw err;}}};}function _unsupportedIterableToArray(o,minLen){if(!o)return;if(typeof o==="string")return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);if(n==="Object"&&o.constructor)n=o.constructor.name;if(n==="Map"||n==="Set")return Array.from(o);if(n==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen);}function _arrayLikeToArray(arr,len){if(len==null||len>arr.length)len=arr.length;for(var i=0,arr2=new Array(len);i<len;i++){arr2[i]=arr[i];}return arr2;}var ServiceFile=function(){function ServiceFile(servicesDumpPath){var absolutePath=arguments.length>1&&arguments[1]!==undefined?arguments[1]:false;(0,_classCallCheck2["default"])(this,ServiceFile);this.validExtensions=['.yaml','.yml','.json','.js'];this._ensureAbsolutePathIsValid(servicesDumpPath);this._servicesDumpPath=servicesDumpPath;this._absolutePath=absolutePath;this._content={services:{}};}(0,_createClass2["default"])(ServiceFile,[{key:"_dumper",get:function get(){var parsed=_path["default"].parse(this._servicesDumpPath);if(['.yaml','.yml'].includes(parsed.ext)){return new _YamlDumper["default"](this._servicesDumpPath,this._content);}if(['.json'].includes(parsed.ext)){return new _JsonDumper["default"](this._servicesDumpPath,this._content);}if(['.js'].includes(parsed.ext)){return new _JsDumper["default"](this._servicesDumpPath,this._content);}}},{key:"_ensureAbsolutePathIsValid",value:function _ensureAbsolutePathIsValid(absolutePath){if(_path["default"].isAbsolute(absolutePath)===false){throw new _ServiceFileNotAbsolute["default"](absolutePath);}var parsed=_path["default"].parse(absolutePath);if(this.validExtensions.includes(parsed.ext)===false){throw new _ServiceFileNotValidExtension["default"](absolutePath);}}},{key:"generateFromContainer",value:function(){var _generateFromContainer=(0,_asyncToGenerator2["default"])(_regenerator["default"].mark(function _callee(container){var _iterator,_step,_step$value,id,definition,_iterator2,_step2,_step2$value,_id,reference;return _regenerator["default"].wrap(function _callee$(_context){while(1){switch(_context.prev=_context.next){case 0:_iterator=_createForOfIteratorHelper(container.definitions);try{for(_iterator.s();!(_step=_iterator.n()).done;){_step$value=(0,_slicedToArray2["default"])(_step.value,2),id=_step$value[0],definition=_step$value[1];this._appendServicesToContent(id,definition,container.defaultDir);}}catch(err){_iterator.e(err);}finally{_iterator.f();}_iterator2=_createForOfIteratorHelper(container._alias);try{for(_iterator2.s();!(_step2=_iterator2.n()).done;){_step2$value=(0,_slicedToArray2["default"])(_step2.value,2),_id=_step2$value[0],reference=_step2$value[1];this._content.services[_id]="@".concat(reference);}}catch(err){_iterator2.e(err);}finally{_iterator2.f();}_context.next=6;return this._dumper.dump();case 6:case"end":return _context.stop();}}},_callee,this);}));function generateFromContainer(_x){return _generateFromContainer.apply(this,arguments);}return generateFromContainer;}()},{key:"_appendServicesToContent",value:function _appendServicesToContent(id,definition){var defaultDir=arguments.length>2&&arguments[2]!==undefined?arguments[2]:null;var classPath=this._getClassPath(id,definition,defaultDir);var args=[];var _iterator3=_createForOfIteratorHelper(definition.args),_step3;try{for(_iterator3.s();!(_step3=_iterator3.n()).done;){var reference=_step3.value;args.push("@".concat(reference.id));}}catch(err){_iterator3.e(err);}finally{_iterator3.f();}var _iterator4=_createForOfIteratorHelper(definition.appendArgs),_step4;try{for(_iterator4.s();!(_step4=_iterator4.n()).done;){var appendReference=_step4.value;args.push("@".concat(appendReference.id));}}catch(err){_iterator4.e(err);}finally{_iterator4.f();}this._content.services[id]={"class":classPath,arguments:args,"abstract":definition["abstract"],parent:definition.parent};}},{key:"_getClassPath",value:function _getClassPath(id,definition){var defaultDir=arguments.length>2&&arguments[2]!==undefined?arguments[2]:null;var classPath=_AutowireIdentifier["default"].decode(id).replace(/__/g,'/');var position=classPath.lastIndexOf("/".concat(definition._Object.name));classPath=classPath.substring(0,position);if(this._absolutePath===false&&defaultDir){return classPath.replace(defaultDir,'');}return classPath;}}]);return ServiceFile;}();exports["default"]=ServiceFile;